package com.hfkj.dao;

import com.hfkj.entity.BsMerWithdrawal;
import com.hfkj.entity.BsMerWithdrawalExample.Criteria;
import com.hfkj.entity.BsMerWithdrawalExample.Criterion;
import com.hfkj.entity.BsMerWithdrawalExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsMerWithdrawalSqlProvider {

    public String countByExample(BsMerWithdrawalExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_mer_withdrawal");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsMerWithdrawalExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_mer_withdrawal");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsMerWithdrawal record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_mer_withdrawal");
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.VALUES("platform_type", "#{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.VALUES("platform_no", "#{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.VALUES("cup_no", "#{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerOrderNo() != null) {
            sql.VALUES("mer_order_no", "#{merOrderNo,jdbcType=INTEGER}");
        }
        
        if (record.getDrawJnl() != null) {
            sql.VALUES("draw_jnl", "#{drawJnl,jdbcType=VARCHAR}");
        }
        
        if (record.getDrawAmt() != null) {
            sql.VALUES("draw_amt", "#{drawAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getDrawFee() != null) {
            sql.VALUES("draw_fee", "#{drawFee,jdbcType=DECIMAL}");
        }
        
        if (record.getDrawMode() != null) {
            sql.VALUES("draw_mode", "#{drawMode,jdbcType=INTEGER}");
        }
        
        if (record.getBatchAutoSettle() != null) {
            sql.VALUES("batch_auto_settle", "#{batchAutoSettle,jdbcType=INTEGER}");
        }
        
        if (record.getBatchNo() != null) {
            sql.VALUES("batch_no", "#{batchNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAcctNo() != null) {
            sql.VALUES("acct_no", "#{acctNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAcctName() != null) {
            sql.VALUES("acct_name", "#{acctName,jdbcType=VARCHAR}");
        }
        
        if (record.getBankNo() != null) {
            sql.VALUES("bank_no", "#{bankNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleNo() != null) {
            sql.VALUES("settle_no", "#{settleNo,jdbcType=VARCHAR}");
        }
        
        if (record.getBankName() != null) {
            sql.VALUES("bank_name", "#{bankName,jdbcType=VARCHAR}");
        }
        
        if (record.getDrawStatus() != null) {
            sql.VALUES("draw_status", "#{drawStatus,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCompleteTime() != null) {
            sql.VALUES("complete_time", "#{completeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsMerWithdrawalExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_id");
        sql.SELECT("mer_no");
        sql.SELECT("mer_name");
        sql.SELECT("platform_type");
        sql.SELECT("platform_no");
        sql.SELECT("cup_no");
        sql.SELECT("mer_order_no");
        sql.SELECT("draw_jnl");
        sql.SELECT("draw_amt");
        sql.SELECT("draw_fee");
        sql.SELECT("draw_mode");
        sql.SELECT("batch_auto_settle");
        sql.SELECT("batch_no");
        sql.SELECT("acct_no");
        sql.SELECT("acct_name");
        sql.SELECT("bank_no");
        sql.SELECT("settle_no");
        sql.SELECT("bank_name");
        sql.SELECT("draw_status");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("complete_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_mer_withdrawal");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsMerWithdrawal record = (BsMerWithdrawal) parameter.get("record");
        BsMerWithdrawalExample example = (BsMerWithdrawalExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_withdrawal");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerOrderNo() != null) {
            sql.SET("mer_order_no = #{record.merOrderNo,jdbcType=INTEGER}");
        }
        
        if (record.getDrawJnl() != null) {
            sql.SET("draw_jnl = #{record.drawJnl,jdbcType=VARCHAR}");
        }
        
        if (record.getDrawAmt() != null) {
            sql.SET("draw_amt = #{record.drawAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getDrawFee() != null) {
            sql.SET("draw_fee = #{record.drawFee,jdbcType=DECIMAL}");
        }
        
        if (record.getDrawMode() != null) {
            sql.SET("draw_mode = #{record.drawMode,jdbcType=INTEGER}");
        }
        
        if (record.getBatchAutoSettle() != null) {
            sql.SET("batch_auto_settle = #{record.batchAutoSettle,jdbcType=INTEGER}");
        }
        
        if (record.getBatchNo() != null) {
            sql.SET("batch_no = #{record.batchNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAcctNo() != null) {
            sql.SET("acct_no = #{record.acctNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAcctName() != null) {
            sql.SET("acct_name = #{record.acctName,jdbcType=VARCHAR}");
        }
        
        if (record.getBankNo() != null) {
            sql.SET("bank_no = #{record.bankNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleNo() != null) {
            sql.SET("settle_no = #{record.settleNo,jdbcType=VARCHAR}");
        }
        
        if (record.getBankName() != null) {
            sql.SET("bank_name = #{record.bankName,jdbcType=VARCHAR}");
        }
        
        if (record.getDrawStatus() != null) {
            sql.SET("draw_status = #{record.drawStatus,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCompleteTime() != null) {
            sql.SET("complete_time = #{record.completeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_withdrawal");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        sql.SET("mer_order_no = #{record.merOrderNo,jdbcType=INTEGER}");
        sql.SET("draw_jnl = #{record.drawJnl,jdbcType=VARCHAR}");
        sql.SET("draw_amt = #{record.drawAmt,jdbcType=DECIMAL}");
        sql.SET("draw_fee = #{record.drawFee,jdbcType=DECIMAL}");
        sql.SET("draw_mode = #{record.drawMode,jdbcType=INTEGER}");
        sql.SET("batch_auto_settle = #{record.batchAutoSettle,jdbcType=INTEGER}");
        sql.SET("batch_no = #{record.batchNo,jdbcType=VARCHAR}");
        sql.SET("acct_no = #{record.acctNo,jdbcType=VARCHAR}");
        sql.SET("acct_name = #{record.acctName,jdbcType=VARCHAR}");
        sql.SET("bank_no = #{record.bankNo,jdbcType=VARCHAR}");
        sql.SET("settle_no = #{record.settleNo,jdbcType=VARCHAR}");
        sql.SET("bank_name = #{record.bankName,jdbcType=VARCHAR}");
        sql.SET("draw_status = #{record.drawStatus,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("complete_time = #{record.completeTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsMerWithdrawalExample example = (BsMerWithdrawalExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsMerWithdrawal record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_withdrawal");
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerOrderNo() != null) {
            sql.SET("mer_order_no = #{merOrderNo,jdbcType=INTEGER}");
        }
        
        if (record.getDrawJnl() != null) {
            sql.SET("draw_jnl = #{drawJnl,jdbcType=VARCHAR}");
        }
        
        if (record.getDrawAmt() != null) {
            sql.SET("draw_amt = #{drawAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getDrawFee() != null) {
            sql.SET("draw_fee = #{drawFee,jdbcType=DECIMAL}");
        }
        
        if (record.getDrawMode() != null) {
            sql.SET("draw_mode = #{drawMode,jdbcType=INTEGER}");
        }
        
        if (record.getBatchAutoSettle() != null) {
            sql.SET("batch_auto_settle = #{batchAutoSettle,jdbcType=INTEGER}");
        }
        
        if (record.getBatchNo() != null) {
            sql.SET("batch_no = #{batchNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAcctNo() != null) {
            sql.SET("acct_no = #{acctNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAcctName() != null) {
            sql.SET("acct_name = #{acctName,jdbcType=VARCHAR}");
        }
        
        if (record.getBankNo() != null) {
            sql.SET("bank_no = #{bankNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleNo() != null) {
            sql.SET("settle_no = #{settleNo,jdbcType=VARCHAR}");
        }
        
        if (record.getBankName() != null) {
            sql.SET("bank_name = #{bankName,jdbcType=VARCHAR}");
        }
        
        if (record.getDrawStatus() != null) {
            sql.SET("draw_status = #{drawStatus,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCompleteTime() != null) {
            sql.SET("complete_time = #{completeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsMerWithdrawalExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}